/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the ScriptStartRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ScriptStartRequest{}

// ScriptStartRequest struct for ScriptStartRequest
type ScriptStartRequest struct {
	ConversationId string `json:"conversation_id"`
	TransactionId *string `json:"transaction_id,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
	Language *string `json:"language,omitempty"`
	StaticData map[string]interface{} `json:"static_data,omitempty"`
	DynamicData map[string]interface{} `json:"dynamic_data,omitempty"`
	// map with string as keys and list of ListItem as values
	ListData map[string]interface{} `json:"list_data,omitempty"`
}

// NewScriptStartRequest instantiates a new ScriptStartRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewScriptStartRequest(conversationId string) *ScriptStartRequest {
	this := ScriptStartRequest{}
	this.ConversationId = conversationId
	return &this
}

// NewScriptStartRequestWithDefaults instantiates a new ScriptStartRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewScriptStartRequestWithDefaults() *ScriptStartRequest {
	this := ScriptStartRequest{}
	return &this
}

// GetConversationId returns the ConversationId field value
func (o *ScriptStartRequest) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *ScriptStartRequest) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *ScriptStartRequest) SetConversationId(v string) {
	o.ConversationId = v
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *ScriptStartRequest) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptStartRequest) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *ScriptStartRequest) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *ScriptStartRequest) SetTransactionId(v string) {
	o.TransactionId = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *ScriptStartRequest) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptStartRequest) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *ScriptStartRequest) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *ScriptStartRequest) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetLanguage returns the Language field value if set, zero value otherwise.
func (o *ScriptStartRequest) GetLanguage() string {
	if o == nil || IsNil(o.Language) {
		var ret string
		return ret
	}
	return *o.Language
}

// GetLanguageOk returns a tuple with the Language field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptStartRequest) GetLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.Language) {
		return nil, false
	}
	return o.Language, true
}

// HasLanguage returns a boolean if a field has been set.
func (o *ScriptStartRequest) HasLanguage() bool {
	if o != nil && !IsNil(o.Language) {
		return true
	}

	return false
}

// SetLanguage gets a reference to the given string and assigns it to the Language field.
func (o *ScriptStartRequest) SetLanguage(v string) {
	o.Language = &v
}

// GetStaticData returns the StaticData field value if set, zero value otherwise.
func (o *ScriptStartRequest) GetStaticData() map[string]interface{} {
	if o == nil || IsNil(o.StaticData) {
		var ret map[string]interface{}
		return ret
	}
	return o.StaticData
}

// GetStaticDataOk returns a tuple with the StaticData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptStartRequest) GetStaticDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.StaticData) {
		return map[string]interface{}{}, false
	}
	return o.StaticData, true
}

// HasStaticData returns a boolean if a field has been set.
func (o *ScriptStartRequest) HasStaticData() bool {
	if o != nil && !IsNil(o.StaticData) {
		return true
	}

	return false
}

// SetStaticData gets a reference to the given map[string]interface{} and assigns it to the StaticData field.
func (o *ScriptStartRequest) SetStaticData(v map[string]interface{}) {
	o.StaticData = v
}

// GetDynamicData returns the DynamicData field value if set, zero value otherwise.
func (o *ScriptStartRequest) GetDynamicData() map[string]interface{} {
	if o == nil || IsNil(o.DynamicData) {
		var ret map[string]interface{}
		return ret
	}
	return o.DynamicData
}

// GetDynamicDataOk returns a tuple with the DynamicData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptStartRequest) GetDynamicDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.DynamicData) {
		return map[string]interface{}{}, false
	}
	return o.DynamicData, true
}

// HasDynamicData returns a boolean if a field has been set.
func (o *ScriptStartRequest) HasDynamicData() bool {
	if o != nil && !IsNil(o.DynamicData) {
		return true
	}

	return false
}

// SetDynamicData gets a reference to the given map[string]interface{} and assigns it to the DynamicData field.
func (o *ScriptStartRequest) SetDynamicData(v map[string]interface{}) {
	o.DynamicData = v
}

// GetListData returns the ListData field value if set, zero value otherwise.
func (o *ScriptStartRequest) GetListData() map[string]interface{} {
	if o == nil || IsNil(o.ListData) {
		var ret map[string]interface{}
		return ret
	}
	return o.ListData
}

// GetListDataOk returns a tuple with the ListData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ScriptStartRequest) GetListDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ListData) {
		return map[string]interface{}{}, false
	}
	return o.ListData, true
}

// HasListData returns a boolean if a field has been set.
func (o *ScriptStartRequest) HasListData() bool {
	if o != nil && !IsNil(o.ListData) {
		return true
	}

	return false
}

// SetListData gets a reference to the given map[string]interface{} and assigns it to the ListData field.
func (o *ScriptStartRequest) SetListData(v map[string]interface{}) {
	o.ListData = v
}

func (o ScriptStartRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ScriptStartRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["conversation_id"] = o.ConversationId
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.Language) {
		toSerialize["language"] = o.Language
	}
	if !IsNil(o.StaticData) {
		toSerialize["static_data"] = o.StaticData
	}
	if !IsNil(o.DynamicData) {
		toSerialize["dynamic_data"] = o.DynamicData
	}
	if !IsNil(o.ListData) {
		toSerialize["list_data"] = o.ListData
	}
	return toSerialize, nil
}

type NullableScriptStartRequest struct {
	value *ScriptStartRequest
	isSet bool
}

func (v NullableScriptStartRequest) Get() *ScriptStartRequest {
	return v.value
}

func (v *NullableScriptStartRequest) Set(val *ScriptStartRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableScriptStartRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableScriptStartRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableScriptStartRequest(val *ScriptStartRequest) *NullableScriptStartRequest {
	return &NullableScriptStartRequest{value: val, isSet: true}
}

func (v NullableScriptStartRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableScriptStartRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


